L11. Subarray with k different integers | 2 Pointers and Sliding Window Playlist

Поделиться
HTML-код
  • Опубликовано: 5 окт 2024

Комментарии • 84

  • @takeUforward
    @takeUforward  6 месяцев назад +133

    There is a slight mistake in the code. Please find the fix below
    while (mpp.size() > k) {
    mpp[nums[l]]--;
    if (mpp[nums[l]] == 0)
    mpp.erase(nums[l]);
    l++;
    }
    The while condition and the value of L

    • @ManishKumar-dk8hl
      @ManishKumar-dk8hl 6 месяцев назад +1

      👍

    • @rainyvideo6936
      @rainyvideo6936 27 дней назад

    • @karthik-varma-1579
      @karthik-varma-1579 7 дней назад +1

      Java Code
      class Solution {
      public int subarraysWithKDistinct(int[] nums, int k) {
      return subArraysLessThanEqualToK(nums,k)-subArraysLessThanEqualToK(nums,k-1);
      }
      public int subArraysLessThanEqualToK(int[] nums,int k){
      int l=0,r=0,count=0;
      HashMap hm = new HashMap();
      while(r k){
      int rm = nums[l];
      hm.put(rm,hm.get(rm)-1);
      if(hm.get(rm) == 0){
      hm.remove(rm);
      }
      l++;
      }
      count += (r-l);
      r++;
      }
      return count;
      }
      }

  • @rohitn8883
    @rohitn8883 6 месяцев назад +110

    Hey Striver,
    I think there are two corrections needed to be done
    the while condition should be while (mp.size() > k)
    and instead of l-1, it should be incremented to l+1

  • @yogeshinba6809
    @yogeshinba6809 6 месяцев назад +28

    Solved this on my own using learnings from previous lectures, thanks striver :)

  • @anubhavpal1071
    @anubhavpal1071 15 дней назад

    Bro u r goated, I was able to solve the problem without looking at the solution thanks to you covering all patterns in the previous problems. Your last few vids helped me in understanding pattern 2 and 3 perfectly.

  • @data-fi4hl
    @data-fi4hl 2 месяца назад +2

    did this question on my own by learning from previous lecture!! thanks striver bhaiya

  • @soumyajit_0
    @soumyajit_0 6 месяцев назад +16

    3 Corrections.
    1) The inner while condition should be while(mp.size>k)
    2) The l=l-1 should be l=l+1 in the inner loop.

  • @trailblazer555
    @trailblazer555 6 месяцев назад +15

    Today's Leetcode Problem of the Day!!!

  • @AdityaMaurya-dw3od
    @AdityaMaurya-dw3od Месяц назад

    Did this question on my own! Feeling so good. The previous lectures helped me

  • @HimanshuYadav-fg8sm
    @HimanshuYadav-fg8sm 6 месяцев назад +8

    Sir There are 2 mistakes thre should be if(map.size()>k)
    and l++ in the place of l=l-1.

  • @AdityaSingh-uy8ms
    @AdityaSingh-uy8ms 6 месяцев назад

    The explanation of the problem and its solutions from basic to optimized solutions... everything is crystal clear ... truely helpful ... thanks

  • @stith_pragya
    @stith_pragya 4 месяца назад +1

    Understood.............Thank You So Much for this wonderful video...........🙏🏻🙏🏻🙏🏻🙏🏻🙏🏻🙏🏻

  • @stith_pragya
    @stith_pragya 4 месяца назад +1

    Understood.....Thank You So Much for this wonderful video..........🙏🏻🙏🏻🙏🏻🙏🏻🙏🏻🙏🏻

  • @RoshanPathak-i4l
    @RoshanPathak-i4l 2 месяца назад

    Hi Striver, I think few corrections required, but I think you have already addressed it, adding in the java reference code, but bro you are awesome.
    class Solution {
    public int subarraysWithKDistinct(int[] nums, int k) {
    return countSubArraysWithGoal(nums, k) - countSubArraysWithGoal(nums, k-1);
    }
    private int countSubArraysWithGoal(int[] nums, int goal){
    if(goal

  • @devanshsingh2
    @devanshsingh2 2 месяца назад

    Solved on my own thanks to you!

  • @Cool96267
    @Cool96267 4 месяца назад

    Thankyou so much Striver for all you efforts throughout in delivering us so much valuable content. Any student / working professional can now be able to transition their career without paying money for courses.
    Would also like your insights on the point :
    While preparing for interviews most of the aspirants are going through the videos solely and solving the question after completely watching the video. And also are feeling lazy trying to solve the question on our own. What is the best way to complete any topic without being lazy and how should an aspirant approach any topic/playlist?

  • @hareshnayak7302
    @hareshnayak7302 5 месяцев назад

    Undeerstood,Thanks Striver for this amazing video.

  • @torishi82
    @torishi82 4 месяца назад

    Understood. Completed full playlist.

  • @wilhelmrudolphfittig3577
    @wilhelmrudolphfittig3577 4 месяца назад +1

    understood !
    L9,L10,L11 are the same.

  • @abhisheksinghdangi5027
    @abhisheksinghdangi5027 6 месяцев назад +9

    Todays lc potd

  • @rushidesai2836
    @rushidesai2836 Месяц назад

    This is a gold question

  • @techmatein
    @techmatein 2 месяца назад

    solved hard question on my own by applying the previous questions logic

  • @Krishna-ti8ys
    @Krishna-ti8ys 6 месяцев назад

    Thank you so much bhaiya. I learned a lot from you. Please make a playlist on greedy as well if possible.

  • @codeman3828
    @codeman3828 5 месяцев назад

    Was able to solve by myself. Thanks

  • @vinaykumarratnala5832
    @vinaykumarratnala5832 2 месяца назад

    Solved before watching the video

  • @oyeesharme
    @oyeesharme Месяц назад

    thanks bhaiya

  • @VinayQ-
    @VinayQ- 10 дней назад

    I think the code sippet liitle bit wrong
    while(mpp.size() > k){
    l=l+1
    }

  • @varrnitjaiswal1484
    @varrnitjaiswal1484 6 месяцев назад +9

    Bro can predict future. Daily problem solvers can relate.

    • @kenil98
      @kenil98 6 месяцев назад

    • @taqimustafa7665
      @taqimustafa7665 6 месяцев назад

      hahaha yes.i had seen the videoes before this and thought i watch the playlist from this video today,saw daily question,was easy to solve from the previous videoes knowledge and now when i open this playlist again,i see this video hahah

  • @117_mainakpaul2
    @117_mainakpaul2 5 дней назад

    Can we use hashset instead of hashmap ??

  • @N1903-q9t
    @N1903-q9t 5 месяцев назад

    striver can you please do problems on in how many ways an array can be splitted based on the given condition

  • @anantsaxena5454
    @anantsaxena5454 3 месяца назад +1

    Solved

  • @ashishsinghNITR
    @ashishsinghNITR 6 месяцев назад

    Hii striver, you are wonderful
    for helping millions of peoples with your knowledge. ❤❤

  • @RadheShyam33455
    @RadheShyam33455 Месяц назад

    Hey can anyone explain me why space complexity is O(n) I think it should be O(k+1) because as soon as size exceeds 2*(k+1) we are shrinking the window .Please rectify me if I am wrong 😊

  • @foziezzz1250
    @foziezzz1250 3 месяца назад +1

    How can we do this in O(N) time instead of O(2N) time ..??❓ 🤔🤔

    • @sid_ofc17
      @sid_ofc17 3 месяца назад

      with sliding window i dont think so

    • @ayushmishra6575
      @ayushmishra6575 14 дней назад

      We can use 3 pointer approach for that

  • @akworld2739
    @akworld2739 4 месяца назад +1

    mujhse ek question bhi nhi ho rha sliding window ka bus brute force soch pa rha hu lag rha hai coding mere bas ki bat nhi

  • @RajanKumar-vf7op
    @RajanKumar-vf7op 6 месяцев назад +12

    class Solution {
    public:
    int helper(vector& nums, int k) {
    int left = 0, right = 0;
    map map;
    int cnt = 0;
    while(right < nums.size()) {
    map[nums[right]]++;
    while(map.size() > k) {
    map[nums[left]]--;
    if(map[nums[left]] == 0)
    map.erase(nums[left]);
    left++;
    }

    cnt += right - left + 1;
    right++;
    }
    return cnt;
    }

    int subarraysWithKDistinct(vector& nums, int k) {
    return helper(nums, k) - helper(nums, k - 1);
    }
    };

  • @knowthrvdo
    @knowthrvdo 3 месяца назад

    00:04 Count the number of subarrays with exactly K different integers.
    02:26 Use two pointers and a sliding window to find subarrays with k different integers
    04:52 Algorithm for counting total number of subarrays with k different integers
    07:12 Using count and frequency to determine valid windows
    09:43 Using sliding window to find subarrays with k different integers.
    12:16 Creating valid subarrays using 2 Pointers and Sliding Window approach
    14:37 Using sliding window to find subarrays with k different integers
    17:03 Using the sliding window technique to solve for subarrays with k different integers.
    19:17 Discussion on time and space complexity with the use of map data structure.
    Crafted by Merlin AI.

  • @niteshkumarjha7914
    @niteshkumarjha7914 6 месяцев назад +2

    here is java solution code
    class Solution {
    public int subarraysWithKDistinct(int[] nums, int k) {
    int subK = helper(nums,k);
    int sub = helper(nums,k-1);
    return subK-sub;
    }
    private int helper(int nums[], int k){
    HashMap map = new HashMap();
    int left=0;
    int right=0;
    int count=0;
    while(rightk){
    map.put(nums[left],map.get(nums[left])-1);
    if(map.get(nums[left])==0){
    map.remove(nums[left]);
    }
    left++;
    }
    count = count+ right-left+1;
    right++;
    }
    return count;
    }
    }

  • @aayushgakhar3525
    @aayushgakhar3525 2 месяца назад

    gives tle for string w exactly k diff chars

  • @shivangitiwari2485
    @shivangitiwari2485 5 месяцев назад

    Understood

  • @prasannavenkkatesh1192
    @prasannavenkkatesh1192 4 месяца назад +1

    Why cant we use set?

    • @sirat_e_islam
      @sirat_e_islam 3 месяца назад

      We need number and its freq set stores single thing not key value pairs

  • @raushankumargupta7018
    @raushankumargupta7018 4 месяца назад

    Striver❤

  • @tanujaSangwan
    @tanujaSangwan 28 дней назад

    This is similar to lats 2 questions

  • @md.sabbirahmed4482
    @md.sabbirahmed4482 6 месяцев назад

    Sir please add OPPS playlist.

  • @sksanoyarali1067
    @sksanoyarali1067 3 месяца назад

    class Solution {
    int subarraywithlessthankequaltok(vector& nums, int k){
    int n=nums.size();
    int l=0,r=0,cnt=0;
    map mpp;
    while(rk){
    mpp[nums[l]]--;
    if(mpp[nums[l]]==0){
    mpp.erase(nums[l]);
    }
    l++;
    }
    cnt=cnt+(r-l+1);
    r++;
    }
    return cnt;
    }
    public:
    int subarraysWithKDistinct(vector& nums, int k) {
    return subarraywithlessthankequaltok(nums,k)-subarraywithlessthankequaltok(nums,k-1);
    }
    };

  • @leslysujith8032
    @leslysujith8032 4 месяца назад

    i im leithls aka the lethal sujith

  • @angeldeveloper
    @angeldeveloper 6 месяцев назад

    🎉🎉

  • @HimanshuYadav-fg8sm
    @HimanshuYadav-fg8sm 6 месяцев назад

    Same code in java
    class Solution {
    public int subarraysWithKDistinct(int[] nums, int k) {
    return fun(nums,k)-fun(nums,k-1);
    }
    int fun(int []nums,int k){
    Map frequencyMap = new HashMap();
    int left = 0, right = 0, count = 0;
    while (right < nums.length) {
    frequencyMap.put(nums[right], frequencyMap.getOrDefault(nums[right], 0) + 1);
    while (frequencyMap.size() > k) {
    frequencyMap.put(nums[left], frequencyMap.get(nums[left]) - 1);
    if (frequencyMap.get(nums[left]) == 0) {
    frequencyMap.remove(nums[left]);
    }
    left++;
    }
    count=count+(right-left+1);
    right++;
    }
    return count;
    }
    }

  • @imdavinder
    @imdavinder 6 месяцев назад

    I have still the confusion like How (

    • @teja1184
      @teja1184 6 месяцев назад

      when sliding window shrinking is happening then at that time we will use k-1 probably this case arises when there is problems ask us to count. Even in the above problem also when we took up to k then we missed few subarrays so at that time we take k-1 . so by subtracting k and (k-1) we get the exact answer

    • @diwakaranagrawal4673
      @diwakaranagrawal4673 6 месяцев назад +11

      for example, k=3
      if we take (i)
      and for (ii)
      so to find for k==3, if we subtract (i) - (ii) => x=3=k
      hope this helps.

    • @imdavinder
      @imdavinder 6 месяцев назад +1

      @@diwakaranagrawal4673 Thank you for the crystal clear explanation !

    • @TarunKumar-cn6in
      @TarunKumar-cn6in 2 месяца назад

      @@diwakaranagrawal4673 we can also do
      it by (

  • @THOSHI-cn6hg
    @THOSHI-cn6hg Месяц назад +1

    ok]

  • @karthik-varma-1579
    @karthik-varma-1579 7 дней назад

    class Solution {
    public int subarraysWithKDistinct(int[] nums, int k) {
    return subArraysLessThanEqualToK(nums,k)-subArraysLessThanEqualToK(nums,k-1);
    }
    public int subArraysLessThanEqualToK(int[] nums,int k){
    int l=0,r=0,count=0;
    HashMap hm = new HashMap();
    while(r k){
    int rm = nums[l];
    hm.put(rm,hm.get(rm)-1);
    if(hm.get(rm) == 0){
    hm.remove(rm);
    }
    l++;
    }
    count += (r-l);
    r++;
    }
    return count;
    }
    }

  • @ChillCoderForever
    @ChillCoderForever 6 месяцев назад +1

    Me first 😂😂😂

  • @smitasingh8942
    @smitasingh8942 Месяц назад

    can someone please correct my code
    class Solution {
    public:
    int subarraysWithKDistinct(vector& nums, int k) {
    int l=0;
    int r=0;
    int cnt=0;
    map m;
    while(rk){
    m[nums[l]]--;
    if(m[nums[l]]==0)m.erase(nums[l]);
    l++;
    }
    if(m.size()==k){
    cnt=cnt+(r-l+1);
    }
    r++;
    }
    return cnt;
    }
    };

  • @ManishKumar-dk8hl
    @ManishKumar-dk8hl 6 месяцев назад +2

    class Solution {
    public int help(int[] arr, int k) {
    int l = 0;
    int r = 0;
    int cnt = 0;
    HashMap mpp = new HashMap();
    while (r < arr.length) {
    mpp.put(arr[r],mpp.getOrDefault(arr[r],0)+1);
    while(mpp.size()>k){
    mpp.put(arr[l],mpp.get(arr[l])-1);
    if(mpp.get(arr[l])==0){
    mpp.remove(arr[l]);
    }
    l++;}
    cnt=cnt+r-l+1;
    r++;
    }
    return cnt;

    }
    public int subarraysWithKDistinct(int[] arr, int k) {
    return help(arr,k)-help(arr,k-1);

    }
    }

  • @shreshthkushwaha
    @shreshthkushwaha 6 месяцев назад

    bruh

  • @dayashankarlakhotia4943
    @dayashankarlakhotia4943 6 месяцев назад

    public int subarraysWithKDistinct(int[]nums,int k){
    return atMostK(nums,k)-atMostK(nums,k-1);
    }
    private int atMostK(int[]nums,int k){
    int ans=0;int[]cnt=new int[nums.length+1];
    for(int l=0,r=0;r